#include "/sys/ins/base.ins.c"
#include "/sys/ins/ios.ins.c"
#include "/sys/ins/trait.ins.c"
#include "/sys/ins/io_traits.ins.c"
#include "/sys/ins/ios_dir_trait.ins.c"
#include "/sys/ins/pfm.ins.c"

#include "v2.h"

extern void
	v2_$openx(),
	v2_$create(),
	v2_$change_name(),
	v2_$inq_name();

extern void v2_$export();
extern void v2_$import();
extern void v2_$pre_fork();
extern void v2_$post_fork();
extern boolean v2_$close();
extern void v2_$get_ec();
extern ios_$mgr_flag_set v2_$inq_mgr_flags();
extern ios_$obj_flag_set v2_$inq_obj_flags();
extern void v2_$set_obj_flag();
extern ios_$conn_flag_set v2_$inq_conn_flags();
extern void v2_$set_conn_flag();
extern long int v2_$get();
extern long int v2_$locate();
extern long v2_$putp();
extern long int v2_$inq_rec_remainder();
extern void v2_$seek();
extern void v2_$seek_full_key();
extern void v2_$seek_short_key();
extern void v2_$seek_to_bof();
extern void v2_$seek_to_eof();
extern unsigned long int v2_$inq_short_key();
extern void v2_$inq_full_key();
extern long int v2_$inq_rec_pos();
extern long int  v2_$inq_byte_pos();
extern void v2_$truncate();
extern long int v2_$inq_cur_rec_len();
extern ios_$rtype_t v2_$inq_rec_type();
extern void v2_$set_rec_type();
extern void v2_$force_write_file();
extern void v2_$inq_file_attr();
extern boolean v2_$equal();

extern ios_$id_t v2_dir_$open();
extern boolean v2_dir_$read();
extern long v2_dir_$telldir();
extern void v2_dir_$seekdir();
extern void v2_dir_$rewinddir();

io_xoc_$epv v2_$openx_epv = {
	v2_$openx,
	v2_$create,
	v2_$change_name,
	v2_$inq_name,
};

io_$epv v2_$io_epv = {
	v2_$export,
	v2_$import,
	v2_$pre_fork,
	v2_$post_fork,
	v2_$close,
	v2_$get_ec,
	v2_$inq_mgr_flags,
	v2_$inq_obj_flags,
	v2_$set_obj_flag,
	v2_$inq_conn_flags,
	v2_$set_conn_flag,
	v2_$get,
	NULL,
	NULL,
	NULL,
	v2_$seek,
	v2_$seek_full_key,
	v2_$seek_short_key,
	v2_$seek_to_bof,
	v2_$seek_to_eof,
	v2_$inq_short_key,
	v2_$inq_full_key,
	NULL,
	v2_$inq_byte_pos,
	v2_$truncate,
	NULL,
	v2_$inq_rec_type,
	v2_$set_rec_type,
	NULL,
	v2_$inq_file_attr,
	v2_$equal,
	NULL,
	v2_$putp,
};

ios_dir_$epv v2_$dir_epv = {
	NULL,
	NULL,
	v2_dir_$open,
	NULL,
	NULL,
	NULL,
	NULL,
	v2_dir_$read,
	v2_dir_$telldir,
	v2_dir_$seekdir,
	v2_dir_$rewinddir,
};

#define kind(x) (trait_$kind_t) (1 << (int) x)

ios_$initialize()
{
	trait_$kind_t k;
	status_$t st;

	k = kind(trait_$kind_local) | kind(trait_$kind_near_remote);

	/*
	 * Directory (v2) type
	 */

	trait_$mgr_dcl(v2_$uid, io_xoc_$trait, k, &v2_$openx_epv, st);
	if (st.all != status_$ok)
		pfm_$error_trap(st);

	trait_$mgr_dcl(v2_$uid, io_$trait, k, &v2_$io_epv, st);
	if (st.all != status_$ok)
		pfm_$error_trap(st);

	trait_$mgr_dcl(v2_$uid, ios_dir_$trait, k, &v2_$dir_epv, st);
	if (st.all != status_$ok)
		pfm_$error_trap(st);

	/*
	 * File (v2f) type
	 */

	trait_$mgr_dcl(v2f_$uid, io_xoc_$trait, k, &v2_$openx_epv, st);
	if (st.all != status_$ok)
		pfm_$error_trap(st);

	trait_$mgr_dcl(v2f_$uid, io_$trait, k, &v2_$io_epv, st);
	if (st.all != status_$ok)
		pfm_$error_trap(st);
}
